// classify.c   // 
#include"mex.h"
#include"math.h"
void classify(double *okcnt, const double *ddgcv, const double *classnumber,
        const double *cg, const double *aaag, const double *netalpha, 
        const double *netd_aa, const double *hyperpara, const double *nn, 
        const double *ddim, const double *vvvg, const double *netpai){
   int j, addr, addrv, addraa, addralp, d, d2, jud, class, c;
   int classn, n, ccg, dim, addraaclass, sizeaa;
   double mdistv[51-1], mdist, ddcv[51-1], mmgc, t1, t2;
   double classmmg[10], maxmg, hp0, hp1;
// ------------------------
   classn=(int)*classnumber; n=(int)*nn; ccg=(int)*cg;
   dim=(int)*ddim; sizeaa=(int)((dim-1)*(dim-1));
   hp0=1.0/hyperpara[0]; hp1=(-1.0)/hyperpara[1]; 
   addr=0; *okcnt=0; t1=clock();
for(j=0;j<n;j++){      
       addrv=0; addralp=0; addraaclass=0; 
   for(class=0;class<classn;class++){classmmg[class]=0.0;}
   for(class=0;class<classn;class++){
      for(c=0;c<ccg;c++){
          for(d=0;d<dim-1;d++){mdistv[d]=0;}
          for(d=0;d<dim-1;d++){
          ddcv[d]=ddgcv[addr+d+1]-vvvg[addrv+d];
          addraa=0; 
              for(d2=0;d2<dim-1;d2++){
              mdistv[d2]+=(aaag[addraaclass+addraa+d])*ddcv[d]; 
                 addraa=addraa+dim-1;
              } // d2
          } // d
          mdist=0;
          for(d2=0;d2<dim-1;d2++){
              mdist+=mdistv[d2]*ddcv[d2];  
              } // d2
         if(mdist<0){mexPrintf("Negative distance \n");}
  mmgc=netalpha[c+addralp]/pow(hyperpara[2]+mdist, hp0)
                    *pow(netd_aa[c+addralp], hp1); 
      addrv=addrv+dim-1; addraaclass=addraaclass+sizeaa;
      classmmg[class]+=mmgc; 
      } // c
      addralp=addralp+ccg; classmmg[class]=netpai[class]*classmmg[class];
   } //class
  maxmg=0; 
  for(class=0;class<classn;class++){
      if(classmmg[class]>maxmg){
          maxmg=classmmg[class];
          jud=class;
      }
  }
  if(jud==(int)(ddgcv[addr]-1)){*okcnt+=1;}
  addr+=dim; 
} // j
 t2=clock(); printf("elapse time= %7.0f\n", t2-t1);
 printf("average time= %7.5f\n", (t2-t1)/n);
}

void mexFunction( int Nreturned, mxArray *returned[], int Noperand, const mxArray *operand[]){
  double *ddgcv, *classnumber, *cg, *aaag, *netalpha, *netd_aa, *hyperpara, *nn,
  *ddim, *vvvg, *netpai, *okcnt;

  returned[0] = mxCreateDoubleMatrix(1,1, mxREAL);
  /* Matlab variables are copied to address of C variables */
  ddgcv = mxGetPr(operand[0]);  classnumber = mxGetPr(operand[1]);  
  cg= mxGetPr(operand[2]);  aaag= mxGetPr(operand[3]);  
  netalpha= mxGetPr(operand[4]);  netd_aa= mxGetPr(operand[5]);  
  hyperpara= mxGetPr(operand[6]);  nn= mxGetPr(operand[7]);  
  ddim= mxGetPr(operand[8]);   vvvg= mxGetPr(operand[9]);
  netpai= mxGetPr(operand[10]);
  okcnt = mxGetPr(returned[0]); // return variable
  classify(okcnt,ddgcv,classnumber,cg,aaag,netalpha,netd_aa,hyperpara,nn,ddim,vvvg,netpai);
}

